--- bindfs-1.10.3/src/bindfs.c	2012-05-18 16:45:33.000000000 +0300
+++ bindfs-new/src/bindfs.c	2012-07-15 12:12:39.748468808 +0300
@@ -54,6 +54,7 @@
 #include <assert.h>
 #include <pwd.h>
 #include <grp.h>
+#include <limits.h>
 #ifdef HAVE_SETXATTR
 #include <sys/xattr.h>
 #endif
@@ -399,9 +400,16 @@
     struct dirent *de;
     struct stat st;
     int result = 0;
-    (void) path;
+    long pc_ret;
     
-    de_buf = malloc(offsetof(struct dirent, d_name) + pathconf(path, _PC_NAME_MAX) + 1);
+    path = process_path(path);
+    
+    pc_ret = pathconf(path, _PC_NAME_MAX);
+    if (pc_ret < 0) {
+        DPRINTF("pathconf failed: %d", errno);
+        pc_ret = NAME_MAX;
+    }
+    de_buf = malloc(offsetof(struct dirent, d_name) + pc_ret + 1);
     
     seekdir(dp, offset);
     while (1) {
